extern double Lots=0.1;
extern int TakeProfit=5;
extern int StopLoss=5;
extern int RSIPos=50;
extern int RSINeg=50;
extern int Slippage=2;
extern int abandon=101;
extern int EmaFast   = 5;
extern int EmaSlow   = 12;
extern int EmaPrice  = PRICE_CLOSE;
extern int RsiPeriod = 14;
extern int RsiPrice  = PRICE_CLOSE;

datetime bartime=0;
int bartick=0;

double p;
int cnt=0;

int OrdersPerSymbol=0;

double bullMA3=0;
double bearMA7=0;
double RSI=0;
bool RSIPOS=0;
bool RSINEG=0;

double TP;
double SL;



int init()
{
if (Symbol()=="AUDUSD") {TakeProfit= 60; StopLoss= 23; abandon=103;}
if (Symbol()=="EURAUD") {TakeProfit= 95; StopLoss=141; abandon=33;}
if (Symbol()=="EURCHF") {TakeProfit= 81; StopLoss= 77; abandon=97;}
if (Symbol()=="EURGBP") {TakeProfit= 11; StopLoss= 77; abandon=108;}
if (Symbol()=="EURJPY") {TakeProfit= 38; StopLoss= 75; abandon=183;}
if (Symbol()=="EURUSD") {TakeProfit=35; StopLoss= 35; abandon=5;}
if (Symbol()=="GBPCHF") {TakeProfit= 79; StopLoss= 98; abandon=113;}
if (Symbol()=="GBPJPY") {TakeProfit= 13; StopLoss= 98; abandon=117;}
if (Symbol()=="GBPUSD") {TakeProfit= 55; StopLoss=100; abandon=69;}
if (Symbol()=="USDCAD") {TakeProfit= 66; StopLoss= 76; abandon=106;}
if (Symbol()=="USDCHF") {TakeProfit=117; StopLoss= 78; abandon=111;}
if (Symbol()=="USDJPY") {TakeProfit= 53; StopLoss= 74; abandon=110;}
}

int deinit()
{
}



int doWhat;
#define doNothing 0
#define doBuy     1
#define doSell    2

int start()
{

   p=Point; if (Digits==3 || Digits==5) p*=10.0;

   // Error checking & bar counting
   if(AccountFreeMargin()<(200*Lots)) {Print("-----NO MONEY"); return(0);}
   if(Bars<100) {Print("-----NO BARS "); return(0);}
   if(bartime!=Time[0]) {bartime=Time[0]; bartick++;}

   bullMA3=iMA(Symbol(),0,3,0,MODE_EMA,PRICE_CLOSE,1) ;
   bearMA7=iMA(Symbol(),0,7,0,MODE_EMA,PRICE_CLOSE,1) ;

   RSI=iRSI(Symbol(),0,2,PRICE_CLOSE,2);

   if(RSI>RSIPos) {RSIPOS=true; RSINEG=false;}
   if(RSI<RSINeg) {RSIPOS=false; RSINEG=true;}

   //
   //
   //    decide what to do
   //
   //
   
      double trendc = iCustom(NULL,0,"ema + rsi binary",EmaFast,EmaSlow,EmaPrice,RsiPeriod,RsiPrice,2,1);
      double trendp = iCustom(NULL,0,"ema + rsi binary",EmaFast,EmaSlow,EmaPrice,RsiPeriod,RsiPrice,2,2);
         doWhat = doNothing;
         if (trendc!=trendp)
         {
            if (trendc== 1) doWhat = doBuy;
            if (trendc==-1) doWhat = doSell;
         }

   //
   //
   //
   //
   //
   
   OrdersPerSymbol=0;
   for(cnt=OrdersTotal();cnt>=0;cnt--)
   {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
         if( OrderSymbol()==Symbol() )
         {
            OrdersPerSymbol++;
         }
   }



   if(OrdersPerSymbol==0)
   {
      if(doWhat==doBuy)
      {
         SL=Ask-(StopLoss*p);
         TP=Ask+(TakeProfit*p);
            OrderSend(Symbol(),OP_BUY,Lots,Ask,Slippage,SL,TP, "BUY"+CurTime(),0,0,White);
         bartick=0;
      }
      if(doWhat==doSell)
      {
         SL=Bid+(StopLoss*p);
         TP=Bid-(TakeProfit*p);
            OrderSend(Symbol(),OP_SELL,Lots,Bid,Slippage,SL,TP ,"SELL"+CurTime(),0,0,Red);
         bartick=0;
      }
   }


if(OrdersPerSymbol==1 && bartick==abandon)
{

if(OrderType()==OP_BUY)
{
OrderClose(OrderTicket(),Lots,Bid,Slippage,White);
SL=Bid+(StopLoss*p);
TP=Bid-(TakeProfit*p);
OrderSend(Symbol(),OP_SELL,Lots,Bid,Slippage,SL,TP ,"SELL"+CurTime(),0,0,Red);
bartick++;
}

if(OrderType()==OP_SELL)
{
OrderClose(OrderTicket(),Lots,Ask,Slippage,Red);
SL=Ask-(StopLoss*p);
TP=Ask+(TakeProfit*p);
OrderSend(Symbol(),OP_BUY,Lots,Ask,Slippage,SL,TP, "BUY"+CurTime(),0,0,White);
bartick++;
}

}
for(cnt=0;cnt<OrdersTotal();cnt++)
{
OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
if( OrderSymbol()==Symbol() )
{
if(OrderType()==OP_BUY)
{
if (OrderMagicNumber()==0)
{
if( Bid-OrderOpenPrice() > 3*Point )
{
OrderClose(OrderTicket(),Lots,Bid,0,White);
return(0);
}
}
}

if(OrderType()==OP_SELL)
{
if (OrderMagicNumber()==0)
{
if( OrderOpenPrice()-Ask > (3*Point) )
{
OrderClose(OrderTicket(),Lots,Ask,0,Red);
return(0);
}
}
}
}
}

return(0);
}